#!/bin/bash

CMD=$1

CXX=arm-apple-darwin9-g++

INCDIR=/var/include
LIBDIR=/var/mobile/Files/Development/install/libgcc
FWKDIR=/var/mobile/Files/Development/install/Cocoa_Touch
OBJXDIR=/var/mobile/Files/Development/ObjX/Library

CFLAGS="-I$INCDIR \
       -I$INCDIR/c++ \
       -I$INCDIR/c++/4.0.0 \
       -I$INCDIR/c++/4.0.0/arm-apple-darwin9 \
       -L$LIBDIR \
       -F$FWKDIR/Frameworks \
       -F$FWKDIR/PrivateFrameworks \
       -framework Foundation \
       -framework CoreFoundation \
       -framework UIKit \
       -framework CoreGraphics \
       -Wall -g -lobjc -bind_at_load \
       -o tmp/a.out \
       Classes/*.mm \
       $OBJXDIR/GUI/*.mm \
       $OBJXDIR/System/*.mm" # \
#      $OBJXDIR/Graphics/*.mm \
#      $OBJXDIR/Data/*.mm \
#      $OBJXDIR/Hardware/*.mm \
#      $OBJXDIR/IO/*.mm

case $CMD in

    compile)

        APPEXEC=$(plutil -key CFBundleExecutable Resources/Info.plist)
        APPNAME=$(plutil -key CFBundleName Resources/Info.plist)
        $CXX $CFLAGS
        mkdir -p "Build/$APPNAME.app"
        mv tmp/a.out "Build/$APPNAME.app/$APPEXEC"
        cp Resources/* "Build/$APPNAME.app"
        ;;

    install)

        APPNAME=$(plutil -key CFBundleName Resources/Info.plist)
        cp -rf "Build/$APPNAME.app" "/Applications"
        uicache
        ;;

    ipa)

        UV=_v
        APPNAME=$(plutil -key CFBundleName Resources/Info.plist)
        APPID=$(plutil -key CFBundleIdentifier Resources/Info.plist)
        APPVER=$(plutil -key CFBundleVersion Resources/Info.plist)
        mkdir -p tmp/Payload
        pushd Build
        cp -rf "$APPNAME.app" ../tmp/Payload
        popd
        pushd tmp
        zip -r "$APPID$UV$APPVER.ipa" Payload
        rm -rf Payload
        popd
        mv -f "tmp/$APPID$UV$APPVER.ipa" Build
        cp "Build/$APPID$UV$APPVER.ipa" "/var/mobile/Downloads/$APPID$UV$APPVER.ipa"
        ;;

    uninstall)

        APPNAME=$(plutil -key CFBundleName Resources/Info.plist)
        rm -rf "/Applications/$APPNAME.app"
        uicache
        ;;

    *)

        echo This script is intended to be invoked by the GNU Make.
        ;;

esac
